{-# LANGUAGE Arrows, CPP #-}
module Main where

#define ENABLE_VIEWER

import Control.Monad
import Control.Arrow
import Data.Maybe
import Data.Complex
import qualified Data.IntMap as IM
import System.IO
import Text.Printf
import System.Environment

import Phisics
import OrbitVM
import Controller
import SubmissionFile
#ifdef ENABLE_VIEWER
import SDLControl
import Control.Concurrent (forkIO, threadDelay, yield)
#endif

import Debug.Trace

import Data.IORef

-- -----------------------------------------------------------

main :: IO ()
main = do
  args <- getArgs
  let n = read $ head $ args ++ ["4001"]
  run n

run :: Int -> IO ()
run n = do
  vm <- newIOVM "../problems/bin4.obf"

#ifdef ENABLE_VIEWER
  oref <- newIORef Nothing
  let scale = case n of
                4001 -> 300000
                4002 -> 400000
                4003 -> 400000
                4004 -> 400000
                _ -> 100000
  forkIO $ startViewer 4 scale vm oref
#endif

  let trace t o = do
        when (t `mod` 1000 == 0) $ do
          return ()
#ifdef ENABLE_VIEWER
        writeIORef oref (Just o)
        yield
#endif
  log <- controlWithTrace trace vm init c
  writeSubmissionFile (show n ++ ".osf") teamID n log

  where
    init = IM.fromList [(addrConf, fromIntegral n), (addrDVx, 0), (addrDVy, 0)]
    c = proc i -> do
          returnA -< 0
